/*
 *  this file contains the following error functions:
 *  sys_error (msg)
 *  i_error (msg)
 *  yyerror (msg)
 *  i_warning (msg)
 *  msg(msg)
 */
/*  I'm not sure how much these are used anymore, but I included the
   ERROR_ON_EXIT #define support here for using RTcmix in the context
   of another application where exit()-ing may not be desirable -- BGG 1/2004
*/

#include <stdio.h>
#include <stdlib.h>

extern int yylineno;

void sys_error(char *msg)
{
   fprintf(stderr, "FATAL SYSTEM ERROR: %s\n", msg);
#ifdef EXIT_ON_ERROR
   exit(1);
#endif /* EXIT_ON_ERROR */
}

void i_error(char *msg)
{
   fprintf(stderr, "FATAL PROGRAM ERROR: %s\n", msg);
#ifdef EXIT_ON_ERROR
   exit(1);
#endif /* EXIT_ON_ERROR */
}

void i_warning(char *msg)
{
   fprintf(stderr, "warning from program: %s\n", msg);
}

void msg(char *msg)
{
   fprintf(stderr, "%s\n", msg);
#ifdef EXIT_ON_ERROR
   exit(1);
#endif /* EXIT_ON_ERROR */
}

void yyerror(char *msg)
{
   fprintf(stderr, "near line %d: %s\n", yylineno, msg);
}

